using System;
using System.IO;
using System.Net;
using System.Threading.Tasks;
using File = TourDataManager.Entities.File;

namespace TourDataManager {
    public class ContentLoadingTask {

        private ITourFilesListFetcher filesFetcher;
        private long tourId;

        public ContentLoadingTask(long tourId, ITourFilesListFetcher filesFetcher){
            this.filesFetcher = filesFetcher;
            this.tourId = tourId;
        }

        
        public void Run(){
            
            Debug.Log($"ContentLoadingTask.Run(){{ tourId = {tourId} }}");
            var files = filesFetcher.FetchFilesAsync(tourId).Result;
            
            
            var webClient = new WebClient();

            var len = files.Length;
            var count = 0;
            foreach (var file in files){
                Debug.Log($"{++count} of {len} | {file.LocalUrl}");
                
                var dir = Path.GetDirectoryName(file.LocalUrl);
                if (!Directory.Exists(dir)) Directory.CreateDirectory(dir);
                webClient.DownloadFile(new Uri(file.Url),file.LocalUrl);
            }
        }

        

    }
}